﻿Imports System.Runtime.InteropServices

Public Class Form1

    <DllImport("gdi32.dll", SetLastError:=True)> _
    Public Shared Function GetPixel(hdc As IntPtr, nXPos As Integer, nYPos As Integer) As UInteger
    End Function
    <DllImport("user32.dll")> _
    Public Shared Function GetDC(ByVal hwnd As IntPtr) As IntPtr
    End Function
    <DllImport("user32.dll")> _
    Public Shared Function ReleaseDC(ByVal hWnd As IntPtr, ByVal hDC As IntPtr) As <MarshalAs(UnmanagedType.Bool)> Boolean
    End Function
    Dim Update_Thread As New Threading.Thread(AddressOf Cursor_Update)
    Delegate Sub SetTextCallback([text] As String)

    Sub Cursor_Update()
        Do

            Dim hdc As IntPtr = GetDC(IntPtr.Zero)

            Dim c As String = Hex(GetPixel(hdc, MousePosition.X, MousePosition.Y))

            ReleaseDC(IntPtr.Zero, hdc)

            Dim R As Long = Val("&H" & Mid(c, 5, 2))
            Dim G As Long = Val("&H" & Mid(c, 3, 2))
            Dim B As Long = Val("&H" & Mid(c, 1, 2))

            set_text("X-" & MousePosition.X & "/Y-" & MousePosition.Y & "/RGB-" & c & "/R-" & R & "/G-" & G & "/B-" & B)

        Loop
    End Sub
    Sub set_text(str As String)
        On Error Resume Next
        If Me.InvokeRequired = True Then

            Dim d As New SetTextCallback(AddressOf set_text)
            Me.Invoke(d, New Object() {[str]})

        Else

            Me.Text = str
            Me.BackColor = System.Drawing.Color.FromArgb(Split(Split(str, "/R-")(1), "/G-")(0), Split(Split(str, "/G-")(1), "/B-")(0), Split(str, "/B-")(1))

        End If
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing

        Update_Thread.Abort()

    End Sub
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Update_Thread.SetApartmentState(Threading.ApartmentState.STA)
        Update_Thread.Start()

    End Sub
End Class
